'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _events = require('events');

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var maxAttempts = 40;

var MongoProcess = function (_EventEmitter) {
  _inherits(MongoProcess, _EventEmitter);

  function MongoProcess(mongod) {
    _classCallCheck(this, MongoProcess);

    var _this = _possibleConstructorReturn(this, (MongoProcess.__proto__ || Object.getPrototypeOf(MongoProcess)).call(this));

    _this.mongod = mongod;
    return _this;
  }

  _createClass(MongoProcess, [{
    key: 'kill',
    value: function kill() {
      var _this2 = this;

      if (this.killed) return;
      this.killed = true;

      var attempts = 1;
      var interval = null;

      var onInterval = function onInterval() {
        if (attempts <= maxAttempts) {
          var signal = attempts < maxAttempts / 2 ? 'SIGTERM' : 'SIGKILL';

          if (!_this2.mongod.dead) {
            try {
              process.kill(_this2.mongod.pid, signal);
            } catch (e) {
              _this2.mongod.dead = true;
            }
          }

          if (_this2.mongod.dead) {
            clearInterval(interval);
            _this2.emit('killed');
          }
          attempts += 1;
        } else {
          clearInterval(interval);
          _this2.emit('error');
        }
      };

      onInterval();
      interval = setInterval(onInterval, 100);
    }
  }]);

  return MongoProcess;
}(_events.EventEmitter);

exports.default = MongoProcess;