'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.Spaceshow = undefined;

var _slicedToArray = function () { function sliceIterator(arr, i) { var _arr = []; var _n = true; var _d = false; var _e = undefined; try { for (var _i = arr[Symbol.iterator](), _s; !(_n = (_s = _i.next()).done); _n = true) { _arr.push(_s.value); if (i && _arr.length === i) break; } } catch (err) { _d = true; _e = err; } finally { try { if (!_n && _i["return"]) _i["return"](); } finally { if (_d) throw _e; } } return _arr; } return function (arr, i) { if (Array.isArray(arr)) { return arr; } else if (Symbol.iterator in Object(arr)) { return sliceIterator(arr, i); } else { throw new TypeError("Invalid attempt to destructure non-iterable instance"); } }; }();

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _events = require('events');

var _MeteorApp = require('./MeteorApp');

var _MeteorApp2 = _interopRequireDefault(_MeteorApp);

var _startPuppeteer = require('./startPuppeteer');

var _startPuppeteer2 = _interopRequireDefault(_startPuppeteer);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var Spaceshow = exports.Spaceshow = function (_EventEmitter) {
  _inherits(Spaceshow, _EventEmitter);

  function Spaceshow(options) {
    _classCallCheck(this, Spaceshow);

    var _this = _possibleConstructorReturn(this, (Spaceshow.__proto__ || Object.getPrototypeOf(Spaceshow)).call(this));

    _this.options = options;

    var _ref = options || {},
        args = _ref.args,
        appDir = _ref.appDir,
        settings = _ref.settings,
        meteorPath = _ref.meteorPath,
        _ref$port = _ref.port,
        port = _ref$port === undefined ? 3000 : _ref$port;

    if (!appDir) throw new Error('appDir not specified!');

    _this.meteorApp = new _MeteorApp2.default({
      args: args,
      appDir: appDir,
      port: port,
      settings: settings,
      meteorPath: meteorPath
    });

    _this.meteorApp.on('stdout', function (data) {
      return _this.emit('stdout', data.toString());
    });
    _this.meteorApp.on('stderr', function (data) {
      return _this.emit('stderr', data.toString());
    });
    return _this;
  }

  _createClass(Spaceshow, [{
    key: 'start',
    value: function start() {
      var _this2 = this;

      return Promise.all([this.meteorApp.launch(), (0, _startPuppeteer2.default)(this.options.puppeteerOptions)]).then(function (_ref2) {
        var _ref3 = _slicedToArray(_ref2, 2),
            meteor = _ref3[0],
            puppeteer = _ref3[1];

        puppeteer.meteor = _this2.meteorApp; // eslint-disable-line no-param-reassign
        puppeteer.on('close', function () {
          meteor.kill();
        });

        return puppeteer.goto('http://localhost:' + (_this2.options.port || 3000)).then(function () {
          return puppeteer;
        });
      });
    }
  }]);

  return Spaceshow;
}(_events.EventEmitter);

exports.default = function (options) {
  var show = new Spaceshow(options);
  return show.start();
};