'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _events = require('events');

var _puppeteer = require('puppeteer');

var _puppeteer2 = _interopRequireDefault(_puppeteer);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var pageFns = ['$', '$$', '$$eval', '$eval', '$x', 'addScriptTag', 'addStyleTag', 'authenticate', 'bringToFront', 'click', 'close', 'content', 'cookies', 'coverage', 'deleteCookie', 'emulate', 'emulateMedia', 'evaluate', 'evaluateHandle', 'evaluateOnNewDocument', 'exposeFunction', 'focus', 'frames', 'goBack', 'goForward', 'goto', 'hover', 'keyboard', 'mainFrame', 'metrics', 'mouse', 'pdf', 'queryObjects', 'reload', 'screenshot', 'select', 'setCacheEnabled', 'setContent', 'setCookie', 'setDefaultNavigationTimeout', 'setExtraHTTPHeaders', 'setJavaScriptEnabled', 'setOfflineMode', 'setRequestInterception', 'setUserAgent', 'setViewport', 'tap', 'target', 'title', 'touchscreen', 'tracing', 'type', 'url', 'viewport', 'waitFor', 'waitForFunction', 'waitForNavigation', 'waitForSelector', 'waitForXPath'];

var PuppeteerWrapper = function (_EventEmitter) {
  _inherits(PuppeteerWrapper, _EventEmitter);

  function PuppeteerWrapper(options) {
    _classCallCheck(this, PuppeteerWrapper);

    var _this = _possibleConstructorReturn(this, (PuppeteerWrapper.__proto__ || Object.getPrototypeOf(PuppeteerWrapper)).call(this));

    _this.options = options;
    return _this;
  }

  _createClass(PuppeteerWrapper, [{
    key: 'init',
    value: function init() {
      var _this2 = this;

      return _puppeteer2.default.launch(this.options).then(function (browser) {
        _this2.browser = browser;
        return _this2.browser.newPage();
      }).then(function (page) {
        _this2.page = page;

        // mirror page functions
        pageFns.forEach(function (fnName) {
          if (fnName === 'close') return;
          if (typeof _this2.page[fnName] === 'function') {
            _this2[fnName] = _this2.page[fnName].bind(_this2.page);
          } else {
            _this2[fnName] = _this2.page[fnName];
          }
        });

        return _this2;
      });
    }
  }, {
    key: 'close',
    value: function close() {
      var _this3 = this;

      this.emit('close');
      return this.page.close().then(function () {
        return _this3.browser.close();
      });
    }
  }]);

  return PuppeteerWrapper;
}(_events.EventEmitter);

exports.default = function (options) {
  var wrapper = new PuppeteerWrapper(options);
  return wrapper.init();
};